/*
    This source file is part of the trafikinfo for android project
    Copyright (C) 2010  Peter Björkman


    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package se.peterbjorkman.android.trafikinfo;

public class CategoryResolver {

    private static final int ROADWORKS                    = 0x00000302;
    private static final int ROADWORKS_MASK               = 0x0000FFFF;
    public  static final int ROADWORKS_BIT                = 0x00000001;
    private static final int ABNORMALTRAFFIC              = 0x00000103;
    private static final int ABNORMALTRAFFIC_MASK         = 0x0000FFFF;
    public  static final int ABNORMALTRAFFIC_BIT          = 0x00000002;
    private static final int ACCIDENT                     = 0x00000203;
    private static final int ACCIDENT_MASK                = 0x0000FFFF;
    public  static final int ACCIDENT_BIT                 = 0x00000004;
    private static final int ROADSURFACEINPOORCONDITION   = 0x09020403;
    private static final int ROADSURFACEINPOORCONDITION_M = 0xFFFFFFFF;
    private static final int WHETERROADCONDITIONS         = 0x02030403;
    private static final int WHETERROADCONDITIONS_MASK    = 0xFFFFFFFF;
    //public  static final int ROADSURFACEINPOORCONDITION_B = 0x00000008;
    private static final int ROADCONDITIONS               = 0x00020403;
    private static final int ROADCONDITIONS_MASK          = 0x00FFFFFF;
    public  static final int ROADCONDITIONS_BIT           = 0x00000010;
    private static final int ANIMALPRESENCEOBSTRUCTION    = 0x00010503;
    private static final int ANIMALPRESENCEOBSTRUCTION_M  = 0x00FFFFFF;
    public  static final int ANIMALPRESENCEOBSTRUCTION_B  = 0x00000020;
    private static final int OBSTRUCTION                  = 0x00000503;
    private static final int OBSTRUCTION_MASK             = 0x0000FFFF;
    public  static final int OBSTRUCTION_BIT              = 0x00000040;
    private static final int TEMPORARYSPEEDLIMIT          = 0x02120102;
    private static final int TEMPORARYSPEEDLIMIT_MASK     = 0xFFFFFFFF;
    public  static final int TEMPORARYSPEEDLIMIT_BIT      = 0x00000080;
    private static final int REROUTING                    = 0x01120102;
    private static final int REROUTING_MASK               = 0xFFFFFFFF;
    public  static final int REROUTING_BIT                = 0x00000100;
    private static final int ROADCLOSED                   = 0x000E0102;
    private static final int ROADCLOSED_MASK              = 0xFFFFFFFF;
    public  static final int ROADCLOSED_BIT               = 0x00000200;
    public  static final int OTHER_BIT                    = 0xF0000000;
    
    public static int getCategoryByType(int type){
        if ((type & ROADWORKS_MASK) == ROADWORKS)
            return ROADWORKS_BIT;
        else if ((type & ANIMALPRESENCEOBSTRUCTION_M) == ANIMALPRESENCEOBSTRUCTION)
                return ANIMALPRESENCEOBSTRUCTION_B;
        else if ((type & ABNORMALTRAFFIC_MASK) == ABNORMALTRAFFIC)
            return ABNORMALTRAFFIC_BIT;
        else if ((type & ACCIDENT_MASK) == ACCIDENT)
            return ACCIDENT_BIT;
        else if ((type & ROADSURFACEINPOORCONDITION_M) == ROADSURFACEINPOORCONDITION)
            return ROADCONDITIONS_BIT;
        else if ((type & ROADCONDITIONS_MASK) == ROADCONDITIONS)
            return ROADCONDITIONS_BIT;
        else if ((type & WHETERROADCONDITIONS_MASK) == WHETERROADCONDITIONS)
                return ROADCONDITIONS_BIT;
        else if ((type & OBSTRUCTION_MASK) == OBSTRUCTION)
            return OBSTRUCTION_BIT;
        else if ((type & TEMPORARYSPEEDLIMIT_MASK) == TEMPORARYSPEEDLIMIT)
            return TEMPORARYSPEEDLIMIT_BIT;
        else if ((type & REROUTING_MASK) == REROUTING)
            return REROUTING_BIT;
        else if ((type & ROADCLOSED_MASK) == ROADCLOSED)
            return ROADCLOSED_BIT;
        else 
            return OTHER_BIT;
    }
}
