/*
    This source file is part of the trafikinfo for android project
    Copyright (C) 2010  Peter Björkman


    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package se.peterbjorkman.android.trafikinfo;

import java.util.Date;
import java.util.List;

import se.peterbjorkman.android.trafikinfo.Exceptions.FetchInfoException;

public interface IDataFetcher {
    public List<String> getAllIds() throws FetchInfoException;

    public List<String> getIdsNewerThan(Date onlyNewerThan)
            throws FetchInfoException;

    public TrafficInfo GetMessageById(int id) throws FetchInfoException;
    
    public void getSituations(Date modifiedSince, ISituationHandler handler) throws FetchInfoException;
    
    public Date getLastTimestamp();
    
    public void SetStatusReciever(IStatusReciever reciver);
}
