/*
    This source file is part of the trafikinfo for android project
    Copyright (C) 2010  Peter Björkman


    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package se.peterbjorkman.android.trafikinfo;

import android.util.Log;

public class Logger {
    public static <T> String createLogtag(Class<T> cl){
        return cl.getSimpleName();
    }
    public static void d(String tag, String message){
        if (Log.isLoggable(tag, Log.DEBUG))
            Log.d(tag,message);
    }
    
    public static void v(String tag, String message){
        if (Log.isLoggable(tag, Log.VERBOSE))
            Log.v(tag,message);
    }
    
    public static void w(String tag, String message){
        if (Log.isLoggable(tag, Log.WARN))
            Log.w(tag,message);
    }
    
    public static void e(String tag, String message){
        if (Log.isLoggable(tag, Log.ERROR))
            Log.e(tag,message);
    }
    
    public static void i(String tag, String message){
        if (Log.isLoggable(tag, Log.INFO))
            Log.i(tag,message);
    }
}
