package se.peterbjorkman.android.trafikinfo;

import java.util.ArrayList;
import java.util.List;

import se.peterbjorkman.android.trafikinfo.Exceptions.FetchInfoException;
import se.peterbjorkman.android.trafikinfo.SituationMapOverlay.OnTapListener;

import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;

public class MapOverviewActivity extends AutoZoomSituationMapActivity implements IDataObserver{
    private static final String LOGTAG = MapOverviewActivity.class.getName();

    ServiceBinder mBinder = new ServiceBinder(this);
    

    public void onCreate(Bundle savedInstanceState) {
        Log.d(LOGTAG, "In onCreate");
        super.onCreate(savedInstanceState);
        getItemizedoverlay().setOnTapListener(new OnTapListener() {
            
            @Override
            public void onTap(SituationOverlayItem item) {
                int id = item.getId();
                Context context = MapOverviewActivity.this;
                InfoDbAdapter dbAdapter = new InfoDbAdapter(context);
                dbAdapter.open();
                Intent launchIntent = new Intent(context,
                        DetailedActivity.class);
                TrafficInfo obj = dbAdapter.getInformationById(id);
                
                List<Long> ids = new ArrayList<Long>(1);
                ids.add((long)id);
                dbAdapter.markSiuationsAsRead(ids, context);
                dbAdapter.close();
                launchIntent.putExtra(DetailedInfoActivity.INTENTEXTRA_INFO, obj);
                Log.d(LOGTAG, "Starting DetailedActivity");
                context.startActivity(launchIntent);
                Log.d(LOGTAG, "after intent to DetailedActivity");
            }
        });

        mBinder.bind(getApplicationContext());
    }
    
    @Override
    protected Cursor getCursor(InfoDbAdapter dbAdapter) {
        return dbAdapter.fetchAllActiveSituationsWithPosition();
    }
    
    @Override
    protected void onDestroy() {
        Log.d(LOGTAG, "In onDestroy");

        mBinder.unbind(getApplicationContext());

        super.onDestroy();
        Log.d(LOGTAG, "Leaving onDestroy");
    }

    @Override
    public void completeDataUpdateDone() {
        addSituationMarkers();
    }

    @Override
    public void errorEncountered(FetchInfoException e) {
        // Nothing to do
    }

    @Override
    public void setStatus(String status, int done, int total) {
        // Nothing to do        
    }
}
