package se.peterbjorkman.android.trafikinfo;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

public class Restriction implements Serializable{

    private static final long serialVersionUID = 1136072582151437272L;
    
    private final Date mFrom;
    private final Date mTo;
    private final int mNumber;  
    private final int mType;
    private final String mTypeName;
    private final int mSpeedLimit;
    private final List<String> mComments;
    
    public Restriction(
            Date from,
            Date to,
            int number,
            int type,
            String typeName,
            int speedLimit,
            List<String> comments)
    {
        mFrom = from;
        mTo = to;
        mNumber = number;  
        mType = type;
        mTypeName = typeName;
        mSpeedLimit = speedLimit;
        mComments = comments;       
    }

    public Date getFrom() {
        return mFrom;
    }

    public Date getTo() {
        return mTo;
    }

    public int getNumber() {
        return mNumber;
    }

    public int getType() {
        return mType;
    }

    public String getTypeName() {
        return mTypeName;
    }

    public int getSpeedLimit() {
        return mSpeedLimit;
    }

    public List<String> getComments() {
        return mComments;
    }
}
