package se.peterbjorkman.android.trafikinfo;

import java.util.Date;
import java.util.List;

import se.peterbjorkman.android.trafikinfo.Exceptions.FetchInfoException;

public class TrafikInfoNuCountyFetcher extends TrafikInfoNuInfoFetcher implements IDataFetcher {

    private final int mCountyCode;
    public TrafikInfoNuCountyFetcher(String deviceId, int versionCode, int countyCode) {
        super(deviceId, versionCode);
        mCountyCode = countyCode;
    }

    @Override
    public List<String> getIdsNewerThan(Date onlyNewerThan)
            throws FetchInfoException {
        String url = "http://api.trafikinfo.nu/listByCounty.php?county=" + mCountyCode;
        
        return getIdsByUrl(onlyNewerThan, url);
    }

    @Override
    public void getSituations(Date modifiedSince,
            ISituationHandler handler) throws FetchInfoException {
        String url = "http://api.trafikinfo.nu/getSituationsByCounty.php?lang=sv-SE" + 
        "&county=" + mCountyCode;
        
        getSituationsByUrl(modifiedSince, handler, url);
    }

}
