/*
    This source file is part of the trafikinfo for android project
    Copyright (C) 2010  Peter Björkman


    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package se.peterbjorkman.android.trafikinfo;

import android.content.SharedPreferences;
import android.content.SharedPreferences.OnSharedPreferenceChangeListener;
import android.content.res.Resources;
import android.os.Bundle;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;
import android.util.Log;

public class TrafikinfoPreferencesActivity extends PreferenceActivity {
    private static final String LOGTAG = TrafikinfoPreferencesActivity.class.getName();
    
    String mModePreferenceKey;
    String mShortIntervalPreferenceKey;
    String mLongIntervalPreferenceKey;
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.d(LOGTAG, "In onCreate");
        addPreferencesFromResource(R.xml.preferences);
        
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(this);
        Resources resourses = getResources();
        mModePreferenceKey = resourses.getString(R.string.autoUpdateKey);
        mShortIntervalPreferenceKey = resourses.getString(R.string.shortIntervalKey);
        mLongIntervalPreferenceKey = resourses.getString(R.string.longIntervalKey);
        
        prefs.registerOnSharedPreferenceChangeListener(new OnSharedPreferenceChangeListener() {
            
            @Override
            public void onSharedPreferenceChanged(SharedPreferences sharedPreferences,
                    String key) {
                Log.d(LOGTAG, "in prefs.onSharedPreferenceChanged");
            if (key.contentEquals(mModePreferenceKey) ||
                key.contentEquals(mShortIntervalPreferenceKey) ||
                key.contentEquals(mLongIntervalPreferenceKey)){
                Log.d(LOGTAG, "in prefs.onSharedPreferenceChanged key match");
                AutoUpdate.updateUpdateAlarmManger(TrafikinfoPreferencesActivity.this);
            }
         }
        });
        
    }
    
    @Override
    protected void  onStop(){
        super.onStop();
        // TODO Remove this work around
        // Work around for onSharedPreferenceChanged not being called all the time.
        AutoUpdate.updateUpdateAlarmManger(TrafikinfoPreferencesActivity.this);
    }
    // How to display the current setting value in the list 
    // http://stackoverflow.com/questions/531427/how-do-i-display-the-current-value-of-an-android-preference-in-the-preference-sum
    // http://www.androidsnippets.org/snippets/34/
}
